package net.mcreator.gts.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Checkbox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.gts.world.inventory.CandyConfigGuiMenu;
import net.mcreator.gts.procedures.CheckDisableCandyVoreProcedure;
import net.mcreator.gts.procedures.CheckDisableCandyThunderMagicProcedure;
import net.mcreator.gts.procedures.CheckDisableCandySwipeProcedure;
import net.mcreator.gts.procedures.CheckDisableCandyStepProcedure;
import net.mcreator.gts.procedures.CheckDisableCandySpitProcedure;
import net.mcreator.gts.procedures.CheckDisableCandySmashProcedure;
import net.mcreator.gts.procedures.CheckDisableCandyShockwaveProcedure;
import net.mcreator.gts.procedures.CheckDisableCandyKickProcedure;
import net.mcreator.gts.procedures.CheckDisableCandyHeartMagicProcedure;
import net.mcreator.gts.procedures.CheckDisableCandyBreachProcedure;
import net.mcreator.gts.network.CandyConfigGuiButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class CandyConfigGuiScreen extends AbstractContainerScreen<CandyConfigGuiMenu> {
	private final static HashMap<String, Object> guistate = CandyConfigGuiMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Checkbox Step;
	Checkbox ShockWave;
	Checkbox kick;
	Checkbox Swipe;
	Checkbox Smash;
	Checkbox Breach;
	Checkbox Vore;
	Checkbox HeartMagic;
	Checkbox Spit;
	Checkbox ThunderMagic;
	Button button_main_menu;

	public CandyConfigGuiScreen(CandyConfigGuiMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 400;
		this.imageHeight = 200;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("gts:textures/screens/candy_config_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.candy_config_gui.label_check_to_disable"), 6, 7, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.candy_config_gui.label_candys_attacks"), 6, 22, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		button_main_menu = Button.builder(Component.translatable("gui.gts.candy_config_gui.button_main_menu"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CandyConfigGuiButtonMessage(0, x, y, z));
				CandyConfigGuiButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 317, this.topPos + 10, 72, 20).build();
		guistate.put("button:button_main_menu", button_main_menu);
		this.addRenderableWidget(button_main_menu);
		Step = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.Step"), this.font).pos(this.leftPos + 21, this.topPos + 38).selected(CheckDisableCandyStepProcedure.execute(world)).build();
		guistate.put("checkbox:Step", Step);
		this.addRenderableWidget(Step);
		ShockWave = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.ShockWave"), this.font).pos(this.leftPos + 81, this.topPos + 38).selected(CheckDisableCandyShockwaveProcedure.execute(world)).build();
		guistate.put("checkbox:ShockWave", ShockWave);
		this.addRenderableWidget(ShockWave);
		kick = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.kick"), this.font).pos(this.leftPos + 172, this.topPos + 38).selected(CheckDisableCandyKickProcedure.execute(world)).build();
		guistate.put("checkbox:kick", kick);
		this.addRenderableWidget(kick);
		Swipe = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.Swipe"), this.font).pos(this.leftPos + 224, this.topPos + 38).selected(CheckDisableCandySwipeProcedure.execute(world)).build();
		guistate.put("checkbox:Swipe", Swipe);
		this.addRenderableWidget(Swipe);
		Smash = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.Smash"), this.font).pos(this.leftPos + 312, this.topPos + 38).selected(CheckDisableCandySmashProcedure.execute(world)).build();
		guistate.put("checkbox:Smash", Smash);
		this.addRenderableWidget(Smash);
		Breach = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.Breach"), this.font).pos(this.leftPos + 21, this.topPos + 69).selected(CheckDisableCandyBreachProcedure.execute(world)).build();
		guistate.put("checkbox:Breach", Breach);
		this.addRenderableWidget(Breach);
		Vore = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.Vore"), this.font).pos(this.leftPos + 97, this.topPos + 69).selected(CheckDisableCandyVoreProcedure.execute(world)).build();
		guistate.put("checkbox:Vore", Vore);
		this.addRenderableWidget(Vore);
		HeartMagic = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.HeartMagic"), this.font).pos(this.leftPos + 210, this.topPos + 69).selected(CheckDisableCandyHeartMagicProcedure.execute(world)).build();
		guistate.put("checkbox:HeartMagic", HeartMagic);
		this.addRenderableWidget(HeartMagic);
		Spit = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.Spit"), this.font).pos(this.leftPos + 151, this.topPos + 69).selected(CheckDisableCandySpitProcedure.execute(world)).build();
		guistate.put("checkbox:Spit", Spit);
		this.addRenderableWidget(Spit);
		ThunderMagic = Checkbox.builder(Component.translatable("gui.gts.candy_config_gui.ThunderMagic"), this.font).pos(this.leftPos + 301, this.topPos + 69).selected(CheckDisableCandyThunderMagicProcedure.execute(world)).build();
		guistate.put("checkbox:ThunderMagic", ThunderMagic);
		this.addRenderableWidget(ThunderMagic);
	}
}
