package net.mcreator.gts.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Checkbox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.gts.world.inventory.GtsCommonGUIMenu;
import net.mcreator.gts.procedures.GtsNaturalHeightDisplayProcedure;
import net.mcreator.gts.procedures.GiantessTurnSpeedDisplayProcedure;
import net.mcreator.gts.procedures.CheckDisableStomachSoundProcedure;
import net.mcreator.gts.procedures.CheckDisableRaidWaveSizeChangeProcedure;
import net.mcreator.gts.procedures.CheckDisableNaturalSpawnProcedure;
import net.mcreator.gts.procedures.CheckDisableLockOnTargetProcedure;
import net.mcreator.gts.procedures.CheckDisableClothingDamageProcedure;
import net.mcreator.gts.procedures.CheckDisableBreakLeavesWhenWalkProcedure;
import net.mcreator.gts.procedures.CheckDisableBelchProcedure;
import net.mcreator.gts.network.GtsCommonGUIButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class GtsCommonGUIScreen extends AbstractContainerScreen<GtsCommonGUIMenu> {
	private final static HashMap<String, Object> guistate = GtsCommonGUIMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Checkbox StomachSound;
	Checkbox ClothingDamage;
	Checkbox RaidSizeIncrease;
	Checkbox NaturalSpawn;
	Checkbox BreakLeaves;
	Checkbox LockOnTarget;
	Checkbox DisableBelch;
	Button button_empty;
	Button button_empty1;
	Button button_empty2;
	Button button_empty3;
	Button button_toki_config;
	Button button_candy_config;
	Button button_reset_to_default;
	Button button_next_page;

	public GtsCommonGUIScreen(GtsCommonGUIMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 400;
		this.imageHeight = 200;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("gts:textures/screens/gts_common_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.gts_common_gui.label_giantess_config_menu"), 9, 11, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.gts_common_gui.label_general_giantess_behavior"), 110, 25, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.gts_common_gui.label_giantess_natural_spawn_height"), 134, 81, -12829636, false);
		guiGraphics.drawString(this.font,

				GtsNaturalHeightDisplayProcedure.execute(world), 292, 81, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.gts_common_gui.label_giantess_pathfinding"), 110, 115, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.gts_common_gui.label_giantess_turn_speed"), 133, 176, -12829636, false);
		guiGraphics.drawString(this.font,

				GiantessTurnSpeedDisplayProcedure.execute(world), 240, 176, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.gts_common_gui.label_page_1"), 360, 10, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		button_empty = Button.builder(Component.translatable("gui.gts.gts_common_gui.button_empty"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new GtsCommonGUIButtonMessage(0, x, y, z));
				GtsCommonGUIButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 318, this.topPos + 76, 30, 20).build();
		guistate.put("button:button_empty", button_empty);
		this.addRenderableWidget(button_empty);
		button_empty1 = Button.builder(Component.translatable("gui.gts.gts_common_gui.button_empty1"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new GtsCommonGUIButtonMessage(1, x, y, z));
				GtsCommonGUIButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		}).bounds(this.leftPos + 351, this.topPos + 76, 30, 20).build();
		guistate.put("button:button_empty1", button_empty1);
		this.addRenderableWidget(button_empty1);
		button_empty2 = Button.builder(Component.translatable("gui.gts.gts_common_gui.button_empty2"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new GtsCommonGUIButtonMessage(2, x, y, z));
				GtsCommonGUIButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		}).bounds(this.leftPos + 271, this.topPos + 171, 30, 20).build();
		guistate.put("button:button_empty2", button_empty2);
		this.addRenderableWidget(button_empty2);
		button_empty3 = Button.builder(Component.translatable("gui.gts.gts_common_gui.button_empty3"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new GtsCommonGUIButtonMessage(3, x, y, z));
				GtsCommonGUIButtonMessage.handleButtonAction(entity, 3, x, y, z);
			}
		}).bounds(this.leftPos + 304, this.topPos + 171, 30, 20).build();
		guistate.put("button:button_empty3", button_empty3);
		this.addRenderableWidget(button_empty3);
		button_toki_config = Button.builder(Component.translatable("gui.gts.gts_common_gui.button_toki_config"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new GtsCommonGUIButtonMessage(4, x, y, z));
				GtsCommonGUIButtonMessage.handleButtonAction(entity, 4, x, y, z);
			}
		}).bounds(this.leftPos + 15, this.topPos + 36, 82, 20).build();
		guistate.put("button:button_toki_config", button_toki_config);
		this.addRenderableWidget(button_toki_config);
		button_candy_config = Button.builder(Component.translatable("gui.gts.gts_common_gui.button_candy_config"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new GtsCommonGUIButtonMessage(5, x, y, z));
				GtsCommonGUIButtonMessage.handleButtonAction(entity, 5, x, y, z);
			}
		}).bounds(this.leftPos + 15, this.topPos + 63, 87, 20).build();
		guistate.put("button:button_candy_config", button_candy_config);
		this.addRenderableWidget(button_candy_config);
		button_reset_to_default = Button.builder(Component.translatable("gui.gts.gts_common_gui.button_reset_to_default"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new GtsCommonGUIButtonMessage(6, x, y, z));
				GtsCommonGUIButtonMessage.handleButtonAction(entity, 6, x, y, z);
			}
		}).bounds(this.leftPos + 10, this.topPos + 169, 108, 20).build();
		guistate.put("button:button_reset_to_default", button_reset_to_default);
		this.addRenderableWidget(button_reset_to_default);
		button_next_page = Button.builder(Component.translatable("gui.gts.gts_common_gui.button_next_page"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new GtsCommonGUIButtonMessage(7, x, y, z));
				GtsCommonGUIButtonMessage.handleButtonAction(entity, 7, x, y, z);
			}
		}).bounds(this.leftPos + 320, this.topPos + 21, 72, 20).build();
		guistate.put("button:button_next_page", button_next_page);
		this.addRenderableWidget(button_next_page);
		StomachSound = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui.StomachSound"), this.font).pos(this.leftPos + 134, this.topPos + 36).selected(CheckDisableStomachSoundProcedure.execute(world)).build();
		guistate.put("checkbox:StomachSound", StomachSound);
		this.addRenderableWidget(StomachSound);
		ClothingDamage = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui.ClothingDamage"), this.font).pos(this.leftPos + 234, this.topPos + 36).selected(CheckDisableClothingDamageProcedure.execute(world)).build();
		guistate.put("checkbox:ClothingDamage", ClothingDamage);
		this.addRenderableWidget(ClothingDamage);
		RaidSizeIncrease = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui.RaidSizeIncrease"), this.font).pos(this.leftPos + 234, this.topPos + 58).selected(CheckDisableRaidWaveSizeChangeProcedure.execute(world)).build();
		guistate.put("checkbox:RaidSizeIncrease", RaidSizeIncrease);
		this.addRenderableWidget(RaidSizeIncrease);
		NaturalSpawn = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui.NaturalSpawn"), this.font).pos(this.leftPos + 134, this.topPos + 58).selected(CheckDisableNaturalSpawnProcedure.execute(world)).build();
		guistate.put("checkbox:NaturalSpawn", NaturalSpawn);
		this.addRenderableWidget(NaturalSpawn);
		BreakLeaves = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui.BreakLeaves"), this.font).pos(this.leftPos + 134, this.topPos + 127).selected(CheckDisableBreakLeavesWhenWalkProcedure.execute(world)).build();
		guistate.put("checkbox:BreakLeaves", BreakLeaves);
		this.addRenderableWidget(BreakLeaves);
		LockOnTarget = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui.LockOnTarget"), this.font).pos(this.leftPos + 134, this.topPos + 149).selected(CheckDisableLockOnTargetProcedure.execute(world)).build();
		guistate.put("checkbox:LockOnTarget", LockOnTarget);
		this.addRenderableWidget(LockOnTarget);
		DisableBelch = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui.DisableBelch"), this.font).pos(this.leftPos + 134, this.topPos + 93).selected(CheckDisableBelchProcedure.execute(world)).build();
		guistate.put("checkbox:DisableBelch", DisableBelch);
		this.addRenderableWidget(DisableBelch);
	}
}
