package net.mcreator.gts.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Checkbox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.gts.world.inventory.GtsCommonGuiPage2Menu;
import net.mcreator.gts.procedures.CheckDisableTamedMobAggroProcedure;
import net.mcreator.gts.procedures.CheckDisableTamedFriendlyFireProcedure;
import net.mcreator.gts.procedures.CheckDisableTamedBreachProcedure;
import net.mcreator.gts.network.GtsCommonGuiPage2ButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class GtsCommonGuiPage2Screen extends AbstractContainerScreen<GtsCommonGuiPage2Menu> {
	private final static HashMap<String, Object> guistate = GtsCommonGuiPage2Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Checkbox TamedFriendlyFire;
	Checkbox TamedHostileAggo;
	Checkbox TamedBreach;
	Button button_previous_page;

	public GtsCommonGuiPage2Screen(GtsCommonGuiPage2Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 400;
		this.imageHeight = 200;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("gts:textures/screens/gts_common_gui_page_2.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.gts_common_gui_page_2.label_giantess_config_main_menu"), 9, 11, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.gts_common_gui_page_2.label_page_2"), 360, 10, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.gts_common_gui_page_2.label_tamed_giantess_config"), 8, 41, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		button_previous_page = Button.builder(Component.translatable("gui.gts.gts_common_gui_page_2.button_previous_page"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new GtsCommonGuiPage2ButtonMessage(0, x, y, z));
				GtsCommonGuiPage2ButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 299, this.topPos + 21, 93, 20).build();
		guistate.put("button:button_previous_page", button_previous_page);
		this.addRenderableWidget(button_previous_page);
		TamedFriendlyFire = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui_page_2.TamedFriendlyFire"), this.font).pos(this.leftPos + 8, this.topPos + 55).selected(CheckDisableTamedFriendlyFireProcedure.execute(world)).build();
		guistate.put("checkbox:TamedFriendlyFire", TamedFriendlyFire);
		this.addRenderableWidget(TamedFriendlyFire);
		TamedHostileAggo = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui_page_2.TamedHostileAggo"), this.font).pos(this.leftPos + 185, this.topPos + 55).selected(CheckDisableTamedMobAggroProcedure.execute(world)).build();
		guistate.put("checkbox:TamedHostileAggo", TamedHostileAggo);
		this.addRenderableWidget(TamedHostileAggo);
		TamedBreach = Checkbox.builder(Component.translatable("gui.gts.gts_common_gui_page_2.TamedBreach"), this.font).pos(this.leftPos + 8, this.topPos + 82).selected(CheckDisableTamedBreachProcedure.execute(world)).build();
		guistate.put("checkbox:TamedBreach", TamedBreach);
		this.addRenderableWidget(TamedBreach);
	}
}
